
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 450
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_ARB_shader_draw_parameters : require
#extension GL_ARB_shader_ballot : require

out float gl_ClipDistance[1];

invariant gl_Position;

struct unaligned_float3
{
    float x;
    float y;
    float z;
};

struct S_TBN
{
    int _iNormal;
    int _iTangent;
};

struct S_INDICES
{
    uint _uiObjectIndex;
    uint _uiMaterialIndex;
    uint _uiMaterialInstanceIndex;
    uint _uiLastFrameMaterialIndex;
    uint _uiLastFrameMaterialInstanceIndex;
    uint _uiPositionsBufferIndex;
    uint _uiPrevPositionsBufferIndex;
    uint _uiNormalsBufferIndex;
    uint _uiPositionOffset;
    uint _uiPrevPositionOffset;
    uint _uiNormalOffset;
    uint _uiMatricesIndex;
};

struct S_MAIN_DEFAULT
{
    S_INDICES _Indices;
};

struct S_MAIN_DEFAULT_ARRAY
{
    S_MAIN_DEFAULT _aMain[32];
};

struct S_MESH_OBJECT
{
    mat4 _mModel;
    mat4 _mModelLast;
    mat4 _mInvModel;
    mat4 _mInvModelLast;
    vec4 _vDiversityOffset;
    uint _uiSceneZoneIndex;
    uint _uiNeighborSceneZoneIndex;
    uint _uiDisplayFlags;
    uint _uiPackedLocalExposureCompensation;
    vec4 _vPortalDirAndDistance;
    int _iPickingID[2];
    float _fLocalExposureCompensation;
    float _fLocalExposureCompensationEV100;
};

struct S_MATERIAL
{
    vec4 _vErrorColor;
    float _fDepthBias;
    float _fDummy0;
    float _fDummy1;
    float _fDummy2;
    float c0;
    float c1;
    float c2;
    float c3;
    uint s0;
    uint s1;
    uint s2;
    uint s3;
    uint s4;
    uint s5;
    uint s6;
    uint s7;
    uint s8;
    uint s9;
    uint s10;
    uint s11;
    uint s12;
    uint s13;
    uint s14;
    uint s15;
};

struct S_MATERIAL_INSTANCE
{
    float c0;
    float c1;
    float c2;
    float c3;
    float c4;
    float c5;
    float c6;
    float c7;
    float _fGloubiboulga;
};

struct S_PASS_MATRICES
{
    mat4 _mViewJitteredProj;
    mat4 _mViewProj;
    mat4 _mView;
    mat4 _mInvView;
    mat4 _mJitteredProj;
};

struct S_EYE_DATA
{
    S_PASS_MATRICES _mCurrentFrameMatrices[2];
    S_PASS_MATRICES _mPreviousFrameMatrices[2];
    mat4 _mJitteredProjection[2];
    mat4 _mNoJitterProjection[2];
    mat4 _mInvViewJitteredProj[2];
    vec4 _vWorldSpaceCameraVector[2];
    vec4 _vWorldSpaceCameraPosition[2];
    vec4 _vFrameBufferScale;
    vec4 _vFrameBufferViewportSize;
    vec4 _vFrameBufferOneOnViewportSize;
    vec4 _vViewportSize;
    vec4 _vFogSubCrop;
    uint _uiAlignment0;
    uint _uiAlignment1;
    float _vCameraJitterDeltaX;
    float _vCameraJitterDeltaY;
    vec4 _vfRcpFVolumetricFogDepthTileSize;
};

struct S_CASCADED_SHADOW
{
    mat4 _mCascadeMatrix[2][8];
    mat4 _mViewSpaceToStaticShadowMapSpace[2];
    vec4 _vfCascadeShadowAttenuation;
    vec4 _vfShadowCascadeTextureTexelSize;
    vec4 _vfStaticShadowBlurRadius;
    vec4 _vfCascadeLinearZProjFactors[8];
    vec4 _vfCascadeParams[8];
};

struct S_CLUSTER_LIGHT_SETUP
{
    S_CASCADED_SHADOW _CascadedShadow;
    vec4 _vfSkinUVParamsAndNormalBias;
    vec4 _vfShadowTextureTexelSize;
    vec4 _vfDummy_SkinFresnelF0AndF90;
    uint _uiCascadedUsed;
    float _fSSSWidth;
    float _fOffsetBias;
    float _fDummy;
};

struct S_CLUSTER_INFO
{
    mat4 _mViewToClusterView[2];
    mat4 _mClusterProjMatrix;
    mat4 _mClusterInvProjMatrix;
    vec4 _vfLeftEyeToCombinedEyeVsDeltaXZ;
    uint _uiFinestMipWidth;
    uint _uiFinestMipHeight;
    uint _uiFinestMipDepth;
    uint _uiFinestMipWidthHeight;
    float _fZSliceGeomFactor;
    float _fRcpLogZSliceGeomFactor;
    float _fDummy0;
    float _fDummy1;
    float _fNearP;
    float _fInvNearP;
    float _fFarP;
    float _fClusterCoincidentWithCamera;
};

struct S_PASS
{
    S_EYE_DATA _EyeData;
    vec4 _avFrustumCorners[4];
    vec4 _vTime;
    vec4 _cFogColor;
    vec4 _vFogSetup;
    vec4 _cSunColor;
    vec4 _vSunDir;
    vec4 _vProjectionSetup;
    vec4 _vProjectionCoeff;
    vec4 _vOutputColor;
    vec4 _vfVsClippingPlane[2];
    S_CLUSTER_LIGHT_SETUP _LightSetup;
    S_CLUSTER_INFO _ClusterInfo;
    float _fIBLIntensity;
    float _fGIIntensity;
    float _fAmbiantOcclusionDirectIntensity;
    float _fAmbiantOcclusionIndirectIntensity;
    float _fNormalSign;
    int _iFogType;
    float _fSelfOcclusionDebugRatio;
    float _fEmissive;
    int _iEnableSkinSSSSS;
    int _iUseHairOpaquePrepass;
    float _fLocalSceneExposure;
    uint _uiDebugMode;
    uint _sFlags;
    float _fTAADropsSharpness;
    uint _uNeoScaleX;
    uint _uNeoScaleY;
    uint _uiDirectOverdrawFilter;
    float _fCoderTest0;
    float _fCoderTest1;
    float _fCoderTest2;
    uint _uiBakeOutput;
    float _fDefaultAmbientIntensity;
    float _fDefaultLightingIntensity;
    uint _uiOutputColor;
    float _fAARotation;
    float _fClampDirectSpecular;
    float _fNearPlane;
    float _fFarPlane;
    float _fNDFFilteringScreenSpaceVariance;
    float _fNDFFilteringThreshold;
    float _fNDFFilteringScreenSpaceVariance_EyeShader;
    float _fNDFFilteringThreshold_EyeShader;
    float _fSurfaceGradientTextureFiltering;
    float _fZero;
    uint _uDepthClamp;
    uint _uiLightDebugMode;
    vec4 _vfFragCoordToDepthTexFactor;
    vec4 _vfFragCoordToDepthTexFactor_HalfRes;
    uint _uHdr;
    uint _uiDrawMayaSwatch;
    float _fEyeRoughnessBias;
    float _fDummy1;
};

layout(set = 1, binding = 39, std430) readonly buffer g_rbVertices_Layout
{
    unaligned_float3 g_rbVertices[];
} g_rbVertices_Buffer[];

layout(set = 1, binding = 40, std430) readonly buffer g_rbTBNs_Layout
{
    S_TBN g_rbTBNs[];
} g_rbTBNs_Buffer[];

layout(set = 0, binding = 52, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_MAIN_ARRAY_BINDING
{
    S_MAIN_DEFAULT_ARRAY g_cbMainArray;
} _1316;

layout(set = 1, binding = 33, std430) readonly buffer g_rbObjects_Layout
{
    S_MESH_OBJECT g_rbObjects[];
} g_rbObjects_Buffer[];

layout(set = 1, binding = 34, std430) readonly buffer g_rbMaterials_Layout
{
    S_MATERIAL g_rbMaterials[];
} g_rbMaterials_Buffer[];

layout(set = 1, binding = 35, std430) readonly buffer g_rbMaterialInstances_Layout
{
    S_MATERIAL_INSTANCE g_rbMaterialInstances[];
} g_rbMaterialInstances_Buffer[];

layout(set = 2, binding = 53, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_PASS_BINDING
{
    S_PASS g_cbPass;
} _1594;

layout(set = 1, binding = 12) uniform sampler2D g_rb2DTextures[];

layout(location = 8) in vec4 in_uv0;
layout(location = 9) in vec4 in_uv1;
layout(location = 23) out float interp_instanceID;

vec3 _8212;

void main()
{
    int _1306 = gl_InstanceIndex + gl_DrawIDARB;
    int _1307 = readFirstInvocationARB(_1306);
    uint _3255 = uint(gl_VertexIndex);
    uint _3258 = _3255 + _1316.g_cbMainArray._aMain[_1307]._Indices._uiPositionOffset;
    uint _3278 = _3255 + _1316.g_cbMainArray._aMain[_1307]._Indices._uiNormalOffset;
    int _3307 = g_rbTBNs_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3278]._iNormal & 1023;
    int _3310 = (g_rbTBNs_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3278]._iNormal >> 10) & 1023;
    int _3313 = (g_rbTBNs_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3278]._iNormal >> 20) & 1023;
    int _8199;
    if (_3307 > 512)
    {
        _8199 = _3307 | (-1024);
    }
    else
    {
        _8199 = _3307;
    }
    int _8201;
    if (_3310 > 512)
    {
        _8201 = _3310 | (-1024);
    }
    else
    {
        _8201 = _3310;
    }
    int _8203;
    if (_3313 > 512)
    {
        _8203 = _3313 | (-1024);
    }
    else
    {
        _8203 = _3313;
    }
    float _3356 = float(_8199);
    float _3359 = float(_8201);
    float _3362 = float(_8203);
    vec3 _3363 = vec3(_3356, _3359, _3362);
    vec3 _3366 = _3363 * vec3(0.001956947147846221923828125);
    vec4 _3499 = vec4(g_rbVertices_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiPositionsBufferIndex].g_rbVertices[_3258].x, g_rbVertices_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiPositionsBufferIndex].g_rbVertices[_3258].y, g_rbVertices_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiPositionsBufferIndex].g_rbVertices[_3258].z, 1.0);
    vec4 _3500 = g_rbObjects_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiObjectIndex].g_rbObjects[0]._mModel * _3499;
    vec3 _3501 = _3500.xyz;
    mat3 _3658 = mat3(g_rbObjects_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[0].xyz, g_rbObjects_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[1].xyz, g_rbObjects_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[2].xyz);
    vec3 _3661 = _3658 * _3366;
    float _3890 = cos(2.0);
    float _3892 = sin(2.0);
    vec2 _3904 = in_uv1.zw - vec2(0.5);
    vec3 _8142 = _8212;
    _8142.y = (textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], (((_3904 * mat2(vec2(_3890, _3892), vec2(-_3892, _3890))) + vec2(0.5)) * vec2(1.25, 3.0)) + vec2(-0.300000011920928955078125, 0.0900000035762786865234375), 0.0) * vec4(1.0, 0.9215819835662841796875, 0.982250988483428955078125, 1.0)).x;
    vec3 _3948 = vec3(g_rbMaterialInstances_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c0);
    vec3 _3951 = mod(_3948, vec3(2.0));
    vec3 _3955 = _8142 * _3951;
    float _3958 = cos(-6.28318500518798828125);
    float _3960 = sin(-6.28318500518798828125);
    vec3 _8151 = _8212;
    _8151.y = (textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], (((_3904 * mat2(vec2(_3958, _3960), vec2(-_3960, _3958))) + vec2(0.5)) * vec2(1.2999999523162841796875)) + vec2(-0.48500001430511474609375, -0.2800000011920928955078125), 0.0) * vec4(1.0, 0.9215819835662841796875, 0.982250988483428955078125, 1.0)).y;
    vec3 _4017 = _3948 * vec3(0.100000001490116119384765625);
    vec3 _4020 = floor(_4017);
    vec3 _4024 = mod(_4020, vec3(2.0));
    vec3 _4028 = _8151 * _4024;
    vec3 _4032 = vec3(1.0) - _3955;
    vec3 _4035 = vec3(1.0) - _4028;
    vec3 _4036 = _4032 * _4035;
    float _4041 = cos(-0.5);
    float _4043 = sin(-0.5);
    vec3 _8160 = _8212;
    _8160.y = (textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], (((_3904 * mat2(vec2(_4041, _4043), vec2(-_4043, _4041))) + vec2(0.5)) * vec2(1.5, 0.75)) + vec2(-0.61000001430511474609375, 0.1500000059604644775390625), 0.0) * vec4(1.0, 0.9215819835662841796875, 0.982250988483428955078125, 1.0)).z;
    vec3 _4100 = _3948 * vec3(0.00999999977648258209228515625);
    vec3 _4103 = floor(_4100);
    vec3 _4107 = mod(_4103, vec3(2.0));
    vec3 _4111 = _8160 * _4107;
    vec3 _4118 = vec3(1.0) - _4111;
    vec3 _4119 = _4036 * _4118;
    vec3 _4121 = vec3(1.0) - _4119;
    float _4123 = _4121.y;
    float _4128 = _4123 - 0.949999988079071044921875;
    float _4133 = _4128 * 19.9959964752197265625;
    float _4134 = clamp(_4133, 0.0, 1.0);
    float _4135 = mix(0.0, 1.0, _4134);
    float _4143 = _4123 - 0.88999998569488525390625;
    float _4148 = _4143 * 99.90019989013671875;
    float _4149 = clamp(_4148, 0.0, 1.0);
    float _4150 = mix(0.0, 1.0, _4149);
    vec3 _4155 = vec3(_4150);
    vec3 _4156 = mix(vec3(0.0), vec3(-0.011610000394284725189208984375), _4155);
    vec3 _4161 = vec3(_4135);
    vec3 _4162 = mix(_4156, vec3(-0.03869999945163726806640625), _4161);
    vec3 _4168 = _4162 * _3661;
    vec3 _4176 = vec3(g_rbMaterialInstances_Buffer[_1316.g_cbMainArray._aMain[_1307]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c1);
    vec3 _4177 = mix(vec3(0.0), _4168, _4176);
    vec3 _4200 = _3501 + _4177;
    float _4265 = _4200.x;
    float _4266 = _4200.y;
    float _4267 = _4200.z;
    vec4 _4268 = vec4(_4265, _4266, _4267, 1.0);
    vec4 _4269 = _1594.g_cbPass._EyeData._mCurrentFrameMatrices[0]._mView * _4268;
    vec4 _4285 = _1594.g_cbPass._EyeData._mCurrentFrameMatrices[0]._mViewJitteredProj * _4268;
    vec4 _8209;
    if (_1594.g_cbPass._uDepthClamp == 4294967295u)
    {
        float _4300 = _4285.w;
        vec4 _8210;
        if ((_4285.z / _4300) > 1.0)
        {
            vec4 _8211;
            if (_4269.z > _1594.g_cbPass._fNearPlane)
            {
                vec4 _8173 = _4285;
                _8173.z = _4300;
                _8211 = _8173;
            }
            else
            {
                _8211 = _4285;
            }
            _8210 = _8211;
        }
        else
        {
            _8210 = _4285;
        }
        _8209 = _8210;
    }
    else
    {
        _8209 = _4285;
    }
    interp_instanceID = float(_1306) + 0.5;
    float _3141 = _4269.x;
    float _3142 = _4269.y;
    float _3143 = _4269.z;
    vec4 _3144 = vec4(_3141, _3142, _3143, 1.0);
    float _3145 = dot(_1594.g_cbPass._vfVsClippingPlane[0], _3144);
    float _3146 = -_3145;
    gl_ClipDistance[0] = _3146;
    gl_Position = _8209;
}

